*! version 1.1 October 12, 2006 @ 16:38:54

program define clean
/*   cleanbank `0'*/

	version 7.0

	syntax varlist(string) [if] [in], [Bank noUPper WORDS(string) PAREN SPACES]

	if `"`words'"' != "" & "`bank'" != "bank" {
		display as error "option words() not allowed unless option bank specified"
		exit 198
	}

	if `"`bank'"' == "bank" & "`upper'" == "noupper" {
		display as error "option noupper not allowed with option bank"
		exit 198
	}

	if "`paren'"=="paren" {
		if "$S_StataSE"=="SE" {
			local strlen = 244
		}
		else {
			local strlen = 80
		}
		tempvar i1 i2
	}


	tempvar touse
	
	local symbols `"~ ! @ # $ % ^ & * ( ) - _ = + [ { ] } \ | ; : ' , < . > / ?"'
	local rwords `"AND THE OF INC CORP CO FSB NA NB GROUP GRP HOLDINGS HLDGS LTD LLC ADR "'
	local rwords `"`rwords' CORPORATION COMPANY LIMITED INCORPORATED "'
	local words = upper(`"`words'"')
	local rwords `"`rwords' `words'"'

	preserve

	quietly {

		generate `touse' = 0
		replace `touse' = 1 `in' `if'

		foreach var of local varlist {
		
			if "`paren'"=="paren" {

				generate `i1' = index(`var', "(")
				generate `i2' = index(`var', ")")

				replace `var' = substr(`var', 1, `i1'-1) + " " + /*
					*/ substr(`var', `i2'+1, .) /*
					*/ if `i1'!=0 & `i2'!=0
				drop `i1' `i2'
			}

			
			foreach symbol of local symbols {
				replace `var' = subinstr(`var',`"`symbol'"'," ",.) if `touse'
			}
			replace `var' = subinstr(`var',"`"," ",.) if `touse'
			replace `var' = subinstr(`var',`"""'," ",.) if `touse'

			if "`upper'"!="noupper" {
				replace `var' = upper(`var')
			}

			if "`bank'"=="bank" {
				foreach rword of local rwords {
					replace `var' = subinword(`var',`"`rword'"'," ",.) if `touse'
				}
			}

			* either cut out all spaces, or just the extra ones between words (default)
			if "`spaces'"=="spaces" {
				replace `var' = subinstr(`var'," ","",.) if `touse'
			}
			else {
				tempvar length
				generate `length' = length(`var')
				summarize `length', meanonly
				local l2 = r(max)/2
				forvalues n = 1/`l2' {
					replace `var' = subinstr(`var',"  "," ",.)
				}
				replace `var' = trim(`var')
			}
			
		} * ends variable loop

	} * ends quietly block
	
	restore, not

end
