
/********************************************
This program takes two words and return the edit distance between them.
********************************************/
capture program drop levnew
program define levnew
	args word1 word2
	
	local L1 = length("`word1'")
	local L2 = length("`word2'")

	matrix A=J(`L2'+1, `L1'+1, 0)					/* Create matrix of zero's */	

	forval i = 0 / `L1'			{				/* Initialize first row */
		matrix A[1,`i'+1] = `i'		
	}

	forval j = 1 / `L2' 		{					/* Initialize first column */
		matrix A[`j'+1,1] = `j'		
	}

	forval j = 1 / `L2'	{						/* Loop through characters of word 2 */
		forval i = 1 / `L1' 	{					/* Loop through characters of word 1 */

			if  substr("`word2'", `j', 1) == substr("`word1'", `i', 1) {
				local cost=0
			}							/*  Set cost=0 if there's a match; */
			else {local cost=1}					/*          cost=1 otherwise	*/
	
			local m = 1 + A[`j', `i'+1]			/* Set current cell equal to min of:	*/
			local n = 1 + A[`j'+1, `i']			/*  cell directly above (m) + 1		*/
			local d = `cost' + A[`j', `i']			/*  cell directly to left (n) + 1		*/
			matrix A[`j'+1,`i'+1]=min(`m',`n',`d')		/*  cell diagonal above & left
(d) + cost  */
		}
	}
	
	local levnew = A[`L2'+1, `L1'+1]					/* Grab the value from bottom, right cell */
								
	di "Levenshtein distance between `word1' and `word2' is `levnew' "

end
