#delim ;
program define longword;

   local origname `0';
   tempvar cleanname;

   /*abbreviate the cleannames to downweight common words*/;
   gen `cleanname' = `origname';
   cleanbank `cleanname';

   /*store the max number of words*/;
   gen wcount = wordcount(`cleanname');
   sum wcount;
   local maxwords = r(max);

   /* this section takes the cleanned name and looks for single letters.
        If there are two single letters in a row, it concatentates them together, then
        looks for a third.  Some databases (such as the NIC) puts things like "SA" or "LP"
        as "S A" and "L P".  This section would switch these to "SA" and "LP".  It would also
        take care of converting "A B C BANK" to "ABC BANK".  */;
   
   forvalues i = 1/`maxwords' {;
      gen word`i' = word(`cleanname',`i');
   };
   forvalues j = 1/`maxwords' {;
      local jminus = `j' -1;
      if `j'==1 {;
         gen concat = word`j';
      };
      else if `j'>1 {;
         replace concat = concat + " " + word`j' if length(word`jminus')>1 | length(word`j')>1;
         replace concat = concat + word`j' if length(word`j')==1 & length(word`jminus')==1;
      };
   };

   replace `cleanname' = trim(concat);
   drop word* concat;
   
   /*extract longest 3 words*/;
   forvalues i = 1/`maxwords' {;
      gen word`i' = word(`cleanname', `i');
      gen wlen`i' = length(word`i');
      if `i'==1 {;
         gen longwd1= word1;
         gen longwd2= "";
         gen longwd3= "";
         gen lwlen1 = length(longwd1);
         gen lwlen2 = length(longwd2);
         gen lwlen3 = length(longwd3);
      };
      else {;
         replace longwd3 = longwd2 if wlen`i' > lwlen1;
         replace longwd2 = longwd1 if wlen`i' > lwlen1;
         replace longwd1 = word`i' if wlen`i' > lwlen1;
         replace longwd3 = longwd2 if wlen`i' > lwlen2 & wlen`i' <= lwlen1;
         replace longwd2 = word`i' if wlen`i' > lwlen2 & wlen`i' <= lwlen1;
         replace longwd3 = word`i' if wlen`i' > lwlen3 & wlen`i' <= lwlen2;
      };
      replace lwlen1 = length(longwd1);
      replace lwlen2 = length(longwd2);
      replace lwlen3 = length(longwd3);
      drop word`i' wlen`i';
   };

   drop `cleanname';

   end;
