*! version 2.0.1 M Blasnik Sep03 
*! performs nearest match merges of nearvar within exact matches of optional varlist 

program define nearmrg
version 8.1

	syntax [varlist(default=none)] using , Nearvar(varname) [Genmatch(str) LOWer UPper ROundup Keepem *]

	if "`keepem'"=="" local mykeep "nokeep"
	if "`genmatch'"!="" confirm new var `genmatch'
	if "`roundup'"=="" local eq="="
	if (("`lower'"!="") + ("`upper'"!="") + ("`roundup'"!=""))>1 {
		di in red "Cannot choose more than one of roundup , lower, upper"
		exit 198
	}

	cap confirm string var `nearvar'
	if _rc==0 & "`lower'`upper'"=="" {
		di in red "Must specific lower or upper when nearvar is string"
		exit 198
	}
	
	local fullvars "`varlist' `nearvar'"
	if "`varlist'"!="" {
		local bycmd "by `varlist': "
	}
	
	quietly {
	
		tempvar order 
		tempfile work
		
		gen long `order'=_n
		
		preserve
		
		keep `order' `fullvars' 
		save `work'
		
		use `fullvars' `using', replace
		sort `fullvars'
		cap isid `fullvars'
		if _rc {
			di in red "`varlist' `nearvar' not unique in using dataset"
			error 459
		}
		
		append using `work'
		sort `fullvars'
		
		tempvar last next mrg gen
		
		gen `last'=`nearvar' if `order'==.
		gen `next'=`last'
		
		`bycmd' replace `last'=`last'[_n-1] if mi(`last')
		
		gsort `varlist' -`nearvar'
		`bycmd' replace `next'=`next'[_n-1] if mi(`next')
		
		if "`lower'"!="" gen `gen'=cond(`nearvar'!=`next',`last',`next')
		if "`upper'"!="" gen `gen'=cond(`nearvar'!=`last',`next',`last')
		if "`upper'`lower'"=="" gen `gen'=cond((`nearvar'-`last')<`eq'abs(`nearvar'-`next'),`last',`next')
		
		drop if `order'==.
		sort `order'
		keep `order' `gen'
		save `work', replace
		save worktemp, replace
		
		/* now get the matching values into original data */
		restore
		sort `order'
		merge `order' using `work' , _merge(`mrg')
		drop `mrg'
		
		/* now shuffle around the names to do the merge into the using dataset */
		tempvar hold
		rename `nearvar' `hold'
		rename `gen' `nearvar'
		sort `fullvars'
		merge `fullvars' `using' , `mykeep' `options'
		rename `nearvar' `gen'
		rename `hold' `nearvar'
		
		if "`genmatch'"!="" {
			gen `genmatch'=`gen'
			local text "`upper'`lower' "
			if "`varlist'"!="" local text2 ", matched on `varlist'"
			label var `genmatch' "nearest `text'match to `nearvar' `text2'"
		}
	}
	
end

