cap program drop print_info
program print_info, rclass
	args lhsvar var fmt file coeff se

	if "`fmt'" == "sigdig" {
		sigdig `coeff' 3
		return local formatted_coeff = "`r(value)'"
	}
	else {
		local formatted_coeff : display %9.`fmt'f `coeff'
		local formatted_coeff : list retok formatted_coeff
		return local formatted_coeff = "`formatted_coeff'"
	}
	
	if ("`var'" != "observations") & ("`var'" != "r_squared") {
		stars `coeff' `se'
		return local stars = "`r(stars)'"
		
		if "`fmt'" == "sigdig" {
			sigdig `se' 3
			return local formatted_se = "`r(value)'"
		}
		else {
			local formatted_se : display %9.`fmt'f `se'
			local formatted_se : list retok formatted_se
			return local formatted_se = "`formatted_se'"
		}
	}
	
	preserve
	use $location/data/raw/table_mapping_data_`file', clear

	foreach varname of varlist * {
		if "`lhsvar'" == "`varname'" {
			return local excel_column = `varname'[1]
		}
		if "`var'" == "`varname'" {
			return local excel_row = `varname'[1]
		}
	}
	restore
end
