* loop through capital gap calculation by quarter

clear all
set more off

* save reserve copy of capital.dta
use "$coredata/capital", clear
save "$coredata/capital_reserve", replace

local counter = 0 

forval i = $startobs/$oldobs {
   // Save relevant Capital
   use "$coredata/capital_long", clear
	keep if date == `i'
	replace date = $oldobs
	save "$coredata/capital_capgaploop", replace

   // Used in Machine to make sure 1-of corrections arent affecting all quarters due to date shift above.
   global loopqtr = `i'
 
   // Run Programs on relevant capital
   global datasuffix = "_capgaploop"
	do "$location/programs/$folder/3machine.do"
	do "$location/programs/$folder/4industry.do"
	do "$location/programs/$folder/6reports.do"

   // Save relevant output
	use "$location/output/tables/capgap_full", clear
	keep if scenario == "cl_redux"
	keep target gap*
	gen date = `i'
	format date %tq
      gen update = 1
	if `counter' == 1 {
		append using "$location/output/tables/accum_capgap_full"
      drop if date == `i' & missing(update)
      drop update
   }
	save "$location/output/tables/accum_capgap_full.dta", replace
	
   foreach scenario in $scenarios {
      use "$location/output/tables/capital_forecasts_`scenario'.dta", clear
      save "$location/output/tables/capital_forecasts/capital_forecasts_`scenario'_q`i'", replace
   }
   
   // Augment the counter, set data suffix back to original
   local counter = 1
   global datasuffix = ""
}

exit, clear
