
* Study sensitivity to asset growth assumption, provisions assumption, and divided assumption

* Sensitivity to Asset Growth Assumption
local first = 1
foreach num in .9875 1 1.0125 1.025 {
   global assetmultiplier = `num'
   do "$location/programs/$folder/1macro.do"
   do "$location/programs/$folder/2regs.do"
   do "$location/programs/$folder/3machine.do"
   do "$location/programs/$folder/4industry.do"
   use "$location/output/tables/industry_data_all", clear
   gen assetmultiplier = `num'
   if `first' == 0 {
      append using "$location/output/tables/industry_data_all_assetmultiplier"
   }
   save "$location/output/tables/industry_data_all_assetmultiplier", replace
   local first = 0
}

global assetmultiplier = 1.0125

* Sensitivity to Provisons Assumption
local first = 1
foreach type in "tunnel_smooth" "NCO" "four_smooth" {
   global provisions = "`type'"
   do "$location/programs/$folder/1macro.do"
   do "$location/programs/$folder/2regs.do"
   do "$location/programs/$folder/3machine.do"
   do "$location/programs/$folder/4industry.do"
   use "$location/output/tables/industry_data_all", clear
   gen provisiontype = "`type'"
   if `first' == 0 {
      append using "$location/output/tables/industry_data_all_provisiontype"
   }
   save "$location/output/tables/industry_data_all_provisiontype", replace
   local first = 0
}

global provisions = "tunnel_smooth" 

* Sensitivity to Dividend Assumption
local first = 1
foreach num in 0 1 0.90 {
   global divar = `num'
   global payout = 0.45
   if `num' == 0 {
      global payout = 0
   }
   do "$location/programs/$folder/1macro.do"
   do "$location/programs/$folder/2regs.do"
   do "$location/programs/$folder/3machine.do"
   do "$location/programs/$folder/4industry.do"
   use "$location/output/tables/industry_data_all", clear
   gen divar = `num'
   if `first' == 0 {
      append using "$location/output/tables/industry_data_all_divar"
   }
   save "$location/output/tables/industry_data_all_divar", replace
   local first = 0
}

