* Appendix graph of historical provision expense and NCOs

	* Calculate provision expense and NCOs as a % of total loans
	use $location/data/$folder/core_industryonly, clear
	replace qllprov = qllprov / ln_tot * 400
	replace qnetxoff_tot = qnetxoff_tot / ln_tot * 400

	* Graph
	twoway line qllprov qnetxoff_tot date, ///
		graphregion(color(white)) ///
		lpattern(shortdash longdash) ///
		xtitle("") ///
		ytitle("") ///
		ylab(0(1)4) ///
		legend(label(1 "Provision Expense") label(2 "Net Chargeoffs"))
	graph save $location/output/figures/appendix_graph1_qllprov_qnetxoff, replace

* Appendix graph of ALLL and realized net chargeoffs

	* Tsset the data
	use $location/data/$folder/core_industryonly, clear
	tsset date

	* Calculate 12-month NCOs as % of total loans
	gen qnetxoff_tot_perc = (f1.qnetxoff_tot + f2.qnetxoff_tot + f3.qnetxoff_tot + f4.qnetxoff_tot) / ln_tot * 100

	* Calculate ALLL as % of total loans
	gen llres_perc = llres / ln_tot * 100

	* Calculate mean of 12-month NCOs as % of total loans
	egen mean_nco = mean(qnetxoff_tot_perc)

	* Graph
	twoway line mean_nco qnetxoff_tot_perc llres_perc date, ///
		graphregion(color(white)) ///
		lpattern(shortdash longdash solid) ///
		xtitle("") ///
		ytitle("") ///
		ylab(0(1)4) ///
		legend(label(1 "Average 12-months NCOs") label(2 "Next 12-months NCOs") label(3 "ALLL"))
	graph save $location/output/figures/appendix_graph2_alll_NCOs, replace
