* Store Point-in-time Capital Gap Data
use "$location/output/tables/accum_capgap_point", clear

keep target gap date
rename gap gap_exante
label var gap_exante "Point-in-time"

tempfile exante
save `exante', replace

* Open Full-Sample Capital Gap Data and merge-in Point-in-time Capital Gap Data
use "$location/output/tables/accum_capgap_full", clear

keep target gap date
rename gap gap_expost
label var gap_expost "Full sample"

merge 1:1 target date using `exante', keepusing(gap_exante) assert(3) nogen
gsort -date target
order target gap* date

* Figure 6 Data
save "$location/output/tables/figure_6", replace


* Figure 6
local titleoptions "size(medium) color(black) bexpand span"
local displayoptions "graph display, ysize(8) xsize(10)"
local legendoptions "size(medsmall) symy(medium) symx(medium) bmargin(zero) rowgap(.5)"
local labelsize "labsize(small)"
local axistitlesize "size(small)"
drop if date < $startobs
local labelskip = 8
local endlab = floor(($oldobs - $startobs) / `labelskip') *`labelskip' + $startobs
sort date
twoway line gap* date if target == 8, ///
  $allgraphs ///
  lpattern(shortdash longdash) /// 
  ytitle("Capital Gap ({c $|}bn), 8% Threshold", `axistitlesize') ///
  ylabel(0(200)800,`labelsize') ///
  xtitle("", `axistitlesize') ///
  xlabel($startobs(`labelskip')`endlab',`labelsize') ///
  legend(size(small))
graph save "$location/output/figures/figure_6", replace


