*******************************************************************************
*******************************************************************************
*******************************************************************************
* EPR_concurrentcapgap is intended to run the real-time capgap using constrained
* regressions.
*******************************************************************************
*******************************************************************************
*******************************************************************************

* this program corresponds to 0doall for EPR
set more off

* Set globals

	* Paths and Folders
		global folder = "EPR_concurrentcapgap" 
		* To core datasets: 
		global coredata = "$location/data/class_data" 
		* Suffix on core datasets:
		global datasuffix = ""

	* Dates and scenarios 
		* Last historical quarter of macro data: 
		global oldobs = tq(2013q3)
		global scenarios = "cl_base cl_redux"
		* Number of quarters in the horizon
		global horizon = 9                  
		global endobs = $oldobs + $horizon 
		* Starting point for the capgap loop
		global startobs = tq(2002q1)			
		global loopqtr = $oldobs	

			*  Model assuptions 
		* Quarterly (gross) asset growth
		global assetmultiplier = 1.0125
		* Closure rule
		global closure = -999999

	* Used in 3machine
		* Method used for computing provisions
		global provisions = "tunnel_smooth"    
		* Number of periods over which to smooth
		global prov_adj_period = 8	
		* Payout rate
		global payout = 0.45    
		* Weight for previous dividends
		global divar = 0.90
		* Tax Rate
		global taxrate = 0.350 
		
	* Graphing
		global allgraphs "nodraw graphregion(color(white))"	



* Run desired subprocess
	do "$location/programs/$folder/11concurrentcapgap.do"


