* Do Loop of Capital Gap by Period

clear all
set more off

* Save reserve copy of capital.dta, and add to capital long. only need to run this once per quarter.
use "$coredata/capital$datasuffix", clear
save "$coredata/capital_reserve", replace
local olddatasuffix = "$datasuffix"

local counter = 0

forval i = $startobs/$oldobs {  
   * Save relevant Core
   use "$coredata/core$datasuffix", replace
   keep if date <= `i'
   save "$coredata/core_concurloop", replace

   * Save relevant Capital
   use "$coredata/capital_long$datasuffix", clear
	keep if date == `i'
	replace date = $oldobs
	save "$coredata/capital_concurloop", replace

   * Used in Machine to make sure 1-off corrections arent affecting all quarters due to date shift above.
   global loopqtr = `i'

   * Run Programs on relevant core and capital
   global datasuffix = "_concurloop"
   do "$location/programs/$folder/2regs.do"   
   do "$location/programs/$folder/3machine.do"
   do "$location/programs/$folder/6reports.do"

   use "$location/output/tables/capgap_point", clear
   keep if scenario == "cl_redux"
   keep target gap*
   gen date = `i'
   format date %tq
   gen update = 1
   if `counter' == 1 {
	  append using "$location/output/tables/accum_capgap_point"
      drop if date == `i' & missing(update)
      drop update
   }
   save "$location/output/tables/accum_capgap_point", replace

   * Augment the counter and set data suffix back to original
   local counter = 1
   global datasuffix = "`olddatasuffix'"
}

exit, clear
